package dev.shadowsoffire.apotheosis.ench.library;

import javax.annotation.Nullable;
import com.google.common.base.Strings;
import java.util.Locale;
import java.util.function.Predicate;
import java.util.Iterator;
import java.util.Collections;
import net.minecraft.world.item.enchantment.Enchantment;
import it.unimi.dsi.fastutil.objects.Object2IntMap;
import net.minecraft.util.Mth;
import net.minecraft.client.resources.sounds.SoundInstance;
import net.minecraft.client.resources.sounds.SimpleSoundInstance;
import net.minecraft.sounds.SoundEvents;
import dev.shadowsoffire.placebo.packets.ButtonClickMessage;
import dev.shadowsoffire.placebo.Placebo;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.ForgeRegistry;
import com.mojang.blaze3d.vertex.PoseStack;
import java.util.stream.Stream;
import net.minecraft.client.gui.Font;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.world.item.ItemStack;
import java.util.Comparator;
import java.util.function.Function;
import java.util.Objects;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import java.util.Collection;
import net.minecraft.client.resources.language.I18n;
import net.minecraft.ChatFormatting;
import net.minecraft.core.registries.BuiltInRegistries;
import dev.shadowsoffire.attributeslib.AttributesLib;
import net.minecraft.network.chat.TextColor;
import net.minecraft.network.chat.Style;
import net.minecraft.network.chat.FormattedText;
import net.minecraft.client.gui.GuiGraphics;
import com.mojang.blaze3d.platform.InputConstants;
import net.minecraft.client.gui.components.events.GuiEventListener;
import java.util.ArrayList;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.network.chat.Component;
import net.minecraft.world.entity.player.Inventory;
import java.text.DecimalFormat;
import net.minecraft.client.gui.components.EditBox;
import java.util.List;
import net.minecraft.resources.ResourceLocation;
import dev.shadowsoffire.apotheosis.adventure.client.AdventureContainerScreen;

public class EnchLibraryScreen extends AdventureContainerScreen<EnchLibraryContainer>
{
    public static final ResourceLocation TEXTURES;
    public static final int MAX_ENTRIES = 5;
    public static final int ENTRY_WIDTH = 113;
    public static final int ENTRY_HEIGHT = 20;
    protected float scrollOffs;
    protected boolean scrolling;
    protected int startIndex;
    protected List<LibrarySlot> data;
    protected EditBox filter;
    private static DecimalFormat f;
    
    public EnchLibraryScreen(final EnchLibraryContainer container, final Inventory inv, final Component title) {
        super((AbstractContainerMenu)container, inv, title);
        this.data = new ArrayList<LibrarySlot>();
        this.filter = null;
        this.f_97727_ = 230;
        container.setNotifier(this::containerChanged);
    }
    
    protected void m_7856_() {
        super.m_7856_();
        (this.filter = (EditBox)this.m_142416_((GuiEventListener)new EditBox(this.f_96547_, this.getGuiLeft() + 16, this.getGuiTop() + 16, 110, 11, this.filter, (Component)Component.m_237113_("")))).m_94182_(false);
        this.filter.m_94202_(9924943);
        this.filter.m_94151_(t -> this.containerChanged());
        this.m_7522_((GuiEventListener)this.filter);
        this.containerChanged();
    }
    
    public boolean m_7933_(final int pKeyCode, final int pScanCode, final int pModifiers) {
        final InputConstants.Key mouseKey = InputConstants.m_84827_(pKeyCode, pScanCode);
        return (this.f_96541_.f_91066_.f_92092_.isActiveAndMatches(mouseKey) && this.m_7222_() == this.filter) || super.m_7933_(pKeyCode, pScanCode, pModifiers);
    }
    
    public void m_88315_(final GuiGraphics gfx, final int mouseX, final int mouseY, final float partialTicks) {
        this.m_280273_(gfx);
        super.m_88315_(gfx, mouseX, mouseY, partialTicks);
        this.m_280072_(gfx, mouseX, mouseY);
    }
    
    protected void m_280072_(final GuiGraphics gfx, final int mouseX, final int mouseY) {
        super.m_280072_(gfx, mouseX, mouseY);
        final LibrarySlot libSlot = this.getHoveredSlot(mouseX, mouseY);
        if (libSlot != null) {
            final List<FormattedText> list = new ArrayList<FormattedText>();
            MutableComponent name = Component.m_237115_(libSlot.ench.m_44704_()).m_6270_(Style.f_131099_.m_131148_(TextColor.m_131266_(16777088)).m_131162_(Boolean.valueOf(true)));
            if (AttributesLib.getTooltipFlag().m_7050_()) {
                name = name.m_7220_((Component)Component.m_237113_(" [" + BuiltInRegistries.f_256876_.m_7981_((Object)libSlot.ench)).m_130948_(Style.f_131099_.m_131140_(ChatFormatting.GRAY).m_131162_(Boolean.valueOf(false))));
            }
            list.add((FormattedText)name);
            if (I18n.m_118936_(libSlot.ench.m_44704_() + ".desc") || AttributesLib.getTooltipFlag().m_7050_()) {
                final Component txt = (Component)Component.m_237115_(libSlot.ench.m_44704_() + ".desc").m_6270_(Style.f_131099_.m_131140_(ChatFormatting.GRAY).m_131155_(Boolean.valueOf(true)));
                list.addAll(this.f_96547_.m_92865_().m_92414_((FormattedText)txt, this.getGuiLeft() - 16, txt.m_7383_()));
                list.add((FormattedText)Component.m_237113_(""));
            }
            list.add((FormattedText)Component.m_237110_("tooltip.enchlib.max_lvl", new Object[] { Component.m_237115_("enchantment.level." + libSlot.maxLvl) }).m_130940_(ChatFormatting.GRAY));
            list.add((FormattedText)Component.m_237110_("tooltip.enchlib.points", new Object[] { format(libSlot.points), format(((EnchLibraryContainer)this.f_97732_).getPointCap()) }).m_130940_(ChatFormatting.GRAY));
            list.add((FormattedText)Component.m_237113_(""));
            final ItemStack outSlot = ((EnchLibraryContainer)this.f_97732_).ioInv.m_8020_(1);
            final int current = EnchantmentHelper.m_44831_(outSlot).getOrDefault(libSlot.ench, 0);
            final boolean shift = Screen.m_96638_();
            int targetLevel = shift ? Math.min(libSlot.maxLvl, 1 + (int)(Math.log(libSlot.points + EnchLibraryTile.levelToPoints(current)) / Math.log(2.0))) : (current + 1);
            if (targetLevel == current) {
                ++targetLevel;
            }
            final int cost = EnchLibraryTile.levelToPoints(targetLevel) - EnchLibraryTile.levelToPoints(current);
            if (targetLevel > libSlot.maxLvl) {
                list.add((FormattedText)Component.m_237115_("tooltip.enchlib.unavailable").m_6270_(Style.f_131099_.m_131140_(ChatFormatting.RED)));
            }
            else {
                list.add((FormattedText)Component.m_237110_("tooltip.enchlib.extracting", new Object[] { Component.m_237115_("enchantment.level." + targetLevel) }).m_130940_(ChatFormatting.BLUE));
                list.add((FormattedText)Component.m_237110_("tooltip.enchlib.cost", new Object[] { cost }).m_130940_((cost > libSlot.points) ? ChatFormatting.RED : ChatFormatting.GOLD));
            }
            final Font f_96547_ = this.f_96547_;
            final List<FormattedText> list2 = list;
            final int n = this.getGuiLeft() - 16;
            final Stream<Object> stream = list.stream();
            final Font f_96547_2 = this.f_96547_;
            Objects.requireNonNull(f_96547_2);
            gfx.renderComponentTooltip(f_96547_, (List)list2, n - stream.map((Function<? super Object, ?>)f_96547_2::m_92852_).max((Comparator<? super Integer>)Integer::compare).get(), mouseY, ItemStack.f_41583_);
        }
    }
    
    protected void m_7286_(final GuiGraphics gfx, final float partial, final int mouseX, final int mouseY) {
        final int left = this.f_97735_;
        final int top = this.f_97736_;
        gfx.m_280163_(EnchLibraryScreen.TEXTURES, left, top, 0.0f, 0.0f, this.f_97726_, this.f_97727_, 307, 256);
        final int scrollbarPos = (int)(90.0f * this.scrollOffs);
        gfx.m_280163_(EnchLibraryScreen.TEXTURES, left + 13, top + 29 + scrollbarPos, 303.0f, (float)(40 + (this.isScrollBarActive() ? 0 : 12)), 4, 12, 307, 256);
        for (int idx = this.startIndex; idx < this.startIndex + 5 && idx < this.data.size(); ++idx) {
            this.renderEntry(gfx, this.data.get(idx), this.f_97735_ + 20, this.f_97736_ + 30 + 20 * (idx - this.startIndex), mouseX, mouseY);
        }
    }
    
    private void renderEntry(final GuiGraphics gfx, final LibrarySlot data, final int x, final int y, final int mouseX, final int mouseY) {
        final LibrarySlot hover = this.getHoveredSlot(mouseX, mouseY);
        gfx.m_280163_(EnchLibraryScreen.TEXTURES, x, y, 194.0f, (data == hover) ? 20.0f : 0.0f, 113, 20, 307, 256);
        final int progress = (int)Math.round(85.0 * Math.sqrt(data.points) / (float)Math.sqrt(((EnchLibraryContainer)this.f_97732_).getPointCap()));
        gfx.m_280163_(EnchLibraryScreen.TEXTURES, x + 3, y + 14, 197.0f, 42.0f, progress, 3, 307, 256);
        final PoseStack stack = gfx.m_280168_();
        stack.m_85836_();
        final Component txt = (Component)Component.m_237115_(data.ench.m_44704_());
        float scale = 1.0f;
        if (this.f_96547_.m_92852_((FormattedText)txt) > 107) {
            scale = 60.0f / this.f_96547_.m_92852_((FormattedText)txt);
        }
        stack.m_85841_(scale, scale, 1.0f);
        gfx.m_280614_(this.f_96547_, txt, (int)((x + 3) / scale), (int)((y + 3) / scale), 9363789, false);
        stack.m_85849_();
    }
    
    public boolean m_6375_(final double pMouseX, final double pMouseY, final int pButton) {
        this.scrolling = false;
        if (this.m_6774_(14, 29, 4, 103, pMouseX, pMouseY)) {
            this.scrolling = true;
            this.m_7979_(pMouseX, pMouseY, pButton, 0.0, 0.0);
            return true;
        }
        final LibrarySlot libSlot = this.getHoveredSlot((int)pMouseX, (int)pMouseY);
        if (libSlot != null) {
            int id = ((ForgeRegistry)ForgeRegistries.ENCHANTMENTS).getID((Object)libSlot.ench);
            if (Screen.m_96638_()) {
                id |= Integer.MIN_VALUE;
            }
            ((EnchLibraryContainer)this.f_97732_).onButtonClick(id);
            Placebo.CHANNEL.sendToServer((Object)new ButtonClickMessage(id));
            this.f_96541_.m_91106_().m_120367_((SoundInstance)SimpleSoundInstance.m_119752_(SoundEvents.f_12495_, 1.0f));
            return true;
        }
        if (this.filter.m_274382_() && pButton == 1) {
            this.filter.m_94144_("");
            return true;
        }
        return super.m_6375_(pMouseX, pMouseY, pButton);
    }
    
    public boolean m_7979_(final double pMouseX, final double pMouseY, final int pButton, final double pDragX, final double pDragY) {
        if (this.scrolling && this.isScrollBarActive()) {
            final int barTop = this.f_97736_ + 14;
            final int barBot = barTop + 103;
            this.scrollOffs = ((float)pMouseY - barTop - 6.0f) / (barBot - barTop - 12.0f) - 0.12f;
            this.scrollOffs = Mth.m_14036_(this.scrollOffs, 0.0f, 1.0f);
            this.startIndex = (int)(this.scrollOffs * this.getOffscreenRows() + 0.5);
            return true;
        }
        return super.m_7979_(pMouseX, pMouseY, pButton, pDragX, pDragY);
    }
    
    public boolean m_6050_(final double pMouseX, final double pMouseY, final double pDelta) {
        if (this.isScrollBarActive()) {
            final int i = this.getOffscreenRows();
            this.scrollOffs -= (float)(pDelta / i);
            this.scrollOffs = Mth.m_14036_(this.scrollOffs, 0.0f, 1.0f);
            this.startIndex = (int)(this.scrollOffs * i + 0.5);
        }
        return true;
    }
    
    private boolean isScrollBarActive() {
        return this.data.size() > 5;
    }
    
    protected int getOffscreenRows() {
        return this.data.size() - 5;
    }
    
    private void containerChanged() {
        this.data.clear();
        final List<Object2IntMap.Entry<Enchantment>> entries = this.filter(((EnchLibraryContainer)this.f_97732_).getPointsForDisplay());
        for (final Object2IntMap.Entry<Enchantment> e : entries) {
            this.data.add(new LibrarySlot((Enchantment)e.getKey(), e.getIntValue(), ((EnchLibraryContainer)this.f_97732_).getMaxLevel((Enchantment)e.getKey())));
        }
        if (!this.isScrollBarActive()) {
            this.scrollOffs = 0.0f;
            this.startIndex = 0;
        }
        Collections.sort(this.data, (a, b) -> I18n.m_118938_(a.ench.m_44704_(), new Object[0]).compareTo(I18n.m_118938_(b.ench.m_44704_(), new Object[0])));
    }
    
    private List<Object2IntMap.Entry<Enchantment>> filter(final List<Object2IntMap.Entry<Enchantment>> list) {
        return list.stream().filter(this::isAllowedByItem).filter(this::isAllowedBySearch).toList();
    }
    
    private boolean isAllowedByItem(final Object2IntMap.Entry<Enchantment> e) {
        final ItemStack stack = ((EnchLibraryContainer)this.f_97732_).ioInv.m_8020_(2);
        return stack.m_41619_() || ((Enchantment)e.getKey()).m_6081_(stack);
    }
    
    private boolean isAllowedBySearch(final Object2IntMap.Entry<Enchantment> e) {
        final String name = I18n.m_118938_(((Enchantment)e.getKey()).m_44704_(), new Object[0]).toLowerCase(Locale.ROOT);
        final String search = (this.filter == null) ? "" : this.filter.m_94155_().trim().toLowerCase(Locale.ROOT);
        return Strings.isNullOrEmpty(search) || ChatFormatting.m_126649_(name).contains(search);
    }
    
    @Nullable
    public LibrarySlot getHoveredSlot(final int mouseX, final int mouseY) {
        for (int i = 0; i < 5; ++i) {
            if (this.startIndex + i < this.data.size() && this.m_6774_(21, 31 + i * 20, 113, 18, (double)mouseX, (double)mouseY)) {
                return this.data.get(this.startIndex + i);
            }
        }
        return null;
    }
    
    public static String format(final int n) {
        final int log = (int)StrictMath.log10(n);
        if (log <= 4) {
            return String.valueOf(n);
        }
        if (log == 5) {
            return EnchLibraryScreen.f.format(n / 1000.0);
        }
        if (log <= 8) {
            return EnchLibraryScreen.f.format(n / 1000000.0);
        }
        return EnchLibraryScreen.f.format(n / 1.0E9);
    }
    
    static {
        TEXTURES = new ResourceLocation("apotheosis", "textures/gui/library.png");
        EnchLibraryScreen.f = new DecimalFormat("##.#");
    }
    
    record LibrarySlot(Enchantment ench, int points, int maxLvl) {}
}
